#include <stdio.h>
#define IDENT_BUFLEN 256

struct erract
{
	int curs;
};

%% erract
{
	# The data that is to go into the fsm structure.
	action hello_fails { printf("hello fails\n");}

	newline = ( any | '\n' @{printf("newline\n");} )*;
	hello = 'hello\n'* $^hello_fails >@/hello_fails;
	main := newline | hello;
}

#include <stdio.h>
#define BUFSIZE 2048

struct erract fsm;
char buf[BUFSIZE];

int main()
{
	erract_init( &fsm );
	while ( 1 ) {
		int len = fread( buf, 1, BUFSIZE, stdin );
		erract_execute( &fsm, buf, len );
		if ( len != BUFSIZE )
			break;
	}
	if ( erract_finish( &fsm ) > 0 )
		printf("ACCEPT\n");
	else
		printf("FAIL\n");
	return 0;
}

