/**
 * Test a high character to make sure signedness 
 * isn't messing us up.
 */

#include <stdio.h>

struct Fsm
{
	int curs;
	%% {
		alphtype unsigned char;
		interface;
	}
};

%% Fsm
{
	# Indicate we got the high character.
	action gothigh {
		printf("yes\n");
	}

	main := 0xe8 @gothigh '\n';
}

#include <stdio.h>
#define BUFSIZE 2048

Fsm fsm;
unsigned char buf[BUFSIZE];

int main()
{
	fsm.init();
	while ( 1 ) {
		int len = fread( buf, 1, BUFSIZE, stdin );
		fsm.execute( buf, len );
		if ( len != BUFSIZE )
			break;
	}
	if ( fsm.finish() > 0 )
		printf("ACCEPT\n");
	else
		printf("FAIL\n");
	return 0;
}

